#include <bits/stdc++.h>

#include "testlib.h"

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        if (params[name].find('e') != string::npos) {
            return (long long)(stod(params[name]));
        }
        return stoll(params[name]);
    } else {
        return def;
    }
}

const int MAX = 1e9;
const int MIN = -1e9;

void put(vector<int>& output) {
    int n = output.size();
    for (int i = 0; i < n; ++i) {
        cout << output[i] << ((i == n - 1) ? "" : " ");
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }

    int n = get("n", 1);
    int minT = get("minT", -1e9);
    int maxT = get("maxT", 1e9);
    int minA = get("minA", 1);
    int maxA = get("maxA", 1e9);
    string modeA = params["modeA"];
    int minB = get("minB", 1);
    int maxB = get("maxB", 1e9);
    string modeB = params["modeB"];
    int blocks_count = get("blocks_count", 1);
    string blocks_mode = params["blocks_mode"];
    if (blocks_mode == "") {
        blocks_mode = "equal";
    }
    bool noise = get("noise");
    int noise_value = get("noise_value");

    int A, B;

    if (modeA == "exact") {
        A = minA;
    } else {
        A = rnd.next(minA, maxA);
    }
    if (modeB == "exact") {
        B = minB;
    } else if (modeB == "A") {
        B = A;
    } else if (modeB == "le") {
        B = rnd.next(minB, A - 1);
    } else if (modeB == "ge") {
        B = rnd.next(A + 1, maxB);
    } else {
        B = rnd.next(minB, maxB);
    }

    cout << n << " ";
    cout << A << " " << B << "\n";

    vector<int> output;

    auto gen_block = [&](int block_size, int value) {
        for (int i = 0; i < block_size; ++i) {
            int t;
            if (noise) {
                t = rnd.next(max(minT, value - noise_value), min(maxT, value + noise_value));
            } else {
                t = value;
            }
            output.push_back(t);
        }
    };

    int prev_block_value = minT;

    for (int i = 0; i < blocks_count; ++i) {
        if (blocks_mode == "equal") {
            int size = n / blocks_count;
            int t = rnd.wnext(prev_block_value, maxT, -5);
            prev_block_value = t;
            if (i == blocks_count - 1) {
                gen_block(n - output.size(), t);
            } else {
                gen_block(size, t);
            }
        } else if (blocks_mode == "near_equal") {
            int size = n / blocks_count;
            size = size + rnd.next(int(-sqrt(size)), int(sqrt(size)));
            if (output.size() + size > n - i) {
                size = output.size() - n + i;
            }
            int t = rnd.wnext(prev_block_value, maxT, -5);
            prev_block_value = t;
            if (i == blocks_count - 1) {
                gen_block(n - output.size(), t);
            } else {
                gen_block(size, t);
            }
        } else if (blocks_mode == "more_big") {
            int size = n / sqrt(blocks_count);
            if (output.size() + size > n - i) {
                size = output.size() - n + i;
            }
            int t = rnd.wnext(prev_block_value, maxT, -5);
            prev_block_value = t;
            if (i == blocks_count - 1) {
                gen_block(n - output.size(), t);
            } else {
                gen_block(size, t);
            }
        }
    }
    shuffle(output.begin(), output.end());
    put(output);
    cout << '\n';
}
