#include <bits/stdc++.h>

#include "testlib.h"

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        if (params[name].find('e') != string::npos) {
            return (long long)(stod(params[name]));
        }
        return stoll(params[name]);
    } else {
        return def;
    }
}

const int MAX = 1e9;
const int MIN = -1e9;

void put(vector<int>& output) {
    int n = output.size();
    for (int i = 0; i < n; ++i) {
        cout << output[i] << ((i == n - 1) ? "" : " ");
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }

    int n = get("n", 1);
    int minT = get("minT", -1e9);
    int maxT = get("maxT", 1e9);
    int minA = get("minA", 1);
    int maxA = get("maxA", 1e9);
    string modeA = params["modeA"];
    int minB = get("minB", 1);
    int maxB = get("maxB", 1e9);
    string modeB = params["modeB"];
    int min_block_size = get("min_block_size");
    bool noise = get("noise");
    int noise_value = get("noise_value");

    int A, B;

    if (modeA == "exact") {
        A = minA;
    } else {
        A = rnd.next(minA, maxA);
    }
    if (modeB == "exact") {
        B = minB;
    } else if (modeB == "A") {
        B = A;
    } else if (modeB == "le") {
        B = rnd.next(minB, A - 1);
    } else if (modeB == "ge") {
        B = rnd.next(A + 1, maxB);
    } else {
        B = rnd.next(minB, maxB);
    }

    cout << n << " ";
    cout << A << " " << B << "\n";

    vector<int> output;

    for (int i = 0; i < min_block_size; ++i) {
        if (noise) {
            int t = rnd.next(max(minT, minT - noise_value), min(maxT, minT + noise_value));
            output.push_back(t);
        } else {
            int t = minT;
            output.push_back(t);
        }
    }
    for (int i = min_block_size; i < n; ++i) {
        if (noise) {
            int t = rnd.next(max(minT, maxT - noise_value), min(maxT, maxT + noise_value));
            output.push_back(t);
        } else {
            int t = maxT;
            output.push_back(t);
        }
    }
    shuffle(output.begin(), output.end());
    put(output);
    cout << '\n';
}
