#include <bits/stdc++.h>

#include <cassert>

#include "testlib.h"

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        if (params[name].find('e') != string::npos) {
            return (long long)(stod(params[name]));
        }
        return stoll(params[name]);
    } else {
        return def;
    }
}

const int MAX = 1e9;
const int MIN = -1e9;

void put(vector<int>& output) {
    int n = output.size();
    for (int i = 0; i < n; ++i) {
        cout << output[i] << ((i == n - 1) ? "" : " ");
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }

    int n = get("n", 1);
    int initT = get("initT", 0);
    int step = get("step");
    int minT = get("minT", -1e9);
    int maxT = get("maxT", 1e9);
    int minA = get("minA", 1);
    int maxA = get("maxA", 1e9);
    string modeA = params["modeA"];
    int minB = get("minB", 1);
    int maxB = get("maxB", 1e9);
    string modeB = params["modeB"];
    bool noise = get("noise");
    int noise_value = get("noise_value");

    int A, B;

    if (modeA == "exact") {
        A = minA;
    } else {
        A = rnd.next(minA, maxA);
    }
    if (modeB == "exact") {
        B = minB;
    } else if (modeB == "A") {
        B = A;
    } else if (modeB == "le") {
        B = rnd.next(minB, A - 1);
    } else if (modeB == "ge") {
        B = rnd.next(A + 1, maxB);
    } else {
        B = rnd.next(minB, maxB);
    }

    cout << n << " ";
    cout << A << " " << B << "\n";

    vector<int> output;

    int prev_t = initT;

    for (int i = 0; i < n; ++i) {
        int next_t = prev_t + step;
        if (noise) {
            int noise_c = 0;
            if (step >= 0) {
                noise_c = rnd.next(0, min(noise_value, maxT - next_t - step * (n - i - 1)));
            } else {
                noise_c = -rnd.next(0, min(noise_value, next_t + step * (n - i - 1) - minT));
            }
            next_t += noise_c;
        }
        prev_t = next_t;
        output.push_back(next_t);
    }
    shuffle(output.begin(), output.end());
    put(output);
    cout << '\n';
}
